﻿'---------------------------------------------------------------------------

'--------------------------------------------------------------------------
Imports MPHID
Public Class mainForm

    Inherits System.Windows.Forms.Form

#Region "Predefined Parameters"
    Enum CommandType As Byte
        CMD_GET_POT = &H37
        CMD_SIM_CAN = &H80
    End Enum

    '------------------------------------------------------------
    'declare a delegate to handle data between threads
    '------------------------------------------------------------
    Delegate Sub ProcessDataDelegateSub(ByRef Data() As Byte)
    Delegate Sub SubNoParams()
#End Region

    '-------------------------------------------------------------------------
    'HID Public Variables
    '-------------------------------------------------------------------------
    Private DataToSend(63) As Byte 'HID Write Data Buffer


    '-----------------------------------------------------------------------
    'Application Variables
    '----------------------------------------------------------------------
    

    '----------------------------------------------------------------------
    'HID USB Class Code For Communications to PIC's
    '______________________________________________________________________

    '**********************************************************************
    'Initiate an instance of the MPHID Class Library
    '**********************************************************************
    Dim WithEvents HIDDevice As HIDClass = New HIDClass
    Dim dVID = &H1246     'VID Number
    Dim dPID = &H1        'Device Number PID

    '---------------------------------------------------------------------------
    'mainForm loading start of application
    '---------------------------------------------------------------------------
    Private Sub mainForm_Load(ByVal sender As System.Object, ByVal e As  _
                              System.EventArgs) Handles MyBase.Load
        '------------------------------------
        'Clear variables on Start up
        '------------------------------------
       

    End Sub
    '---------------------------------------------------------------------------
    ' MainForm Closing - application Closing
    '---------------------------------------------------------------------------
    Private Sub mainForm_FormClosing(ByVal sender As System.Object, ByVal _
        e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        HIDDevice.USBListen = False
        HIDDevice.DisconnectDevice()
    End Sub
    '--------------------------------------------------------------------------------
    'This function enumerates the device that windows knows the device is 'connected
    '--------------------------------------------------------------------------------
    Private Sub EnumDevices()
        Dim ED As SubNoParams = New SubNoParams(AddressOf EnumDevices)
        If InvokeRequired Then
            Invoke(ED)
        Else
            Dim DeviceNames(0) As String
            HIDClass.EnumDevices(dVID, dPID, DeviceNames)
            HIDDevice.VID = dVID
            HIDDevice.PID = dPID
            HIDDevice.DeviceIndex = 0
            HIDDevice.USBListen = True
            If DeviceNames(0) <> "" Then
                '----------------------------------------------
                ' do something to indicate device is connected
                '----------------------------------------------
                lblDevice.Text = "Device found"
            Else
                If HIDDevice.USBListen Then
                    HIDDevice.USBListen = False
                    HIDDevice.DisconnectDevice()
                    '----------------------------------------------
                    ' do something to indicate device is connected
                    '----------------------------------------------
                    lblDevice.Text = "Device not found"
                End If
            End If
        End If
    End Sub

    '-------------------------------------------------------------------------------
    'Check if device is removed or attcahed 
    '--------------------------------------------------------------------------------
    Private Sub HIDDevice_DevicesAddedRemoved() Handles HIDDevice.DevicesAddedRemoved
        EnumDevices()
    End Sub
    '-------------------------------------------------------------------------------
    'On Timer tick every 100mSec Write data to device 
    '------------------------------------------------------------------------------
    Private Sub HidWriteTimer_Tick(ByVal sender As System.Object, ByVal e _
                             As System.EventArgs) Handles HidWriteTimer.Tick
        '------------------------------------------------------------------------
        'These commands send a single byte as a command as defined in the 
        'region decleration
        '-------------------------------------------------------------------
        'HIDDevice.SendPacket(New CommandType(){CommandType.CMD_SIM_CAN})
        'HIDDevice.SendPacket(New CommandType(){CommandType.CMD_GET_POT})
        '---------------------------------------------------------------------
        'initializes the Send data Buffer here 
        '---------------------------------------------------------------------
        DataToSend(0) = 0
        DataToSend(1) = 0
        DataToSend(2) = 0
        DataToSend(5) = 0
        DataToSend(6) = 0
        DataToSend(7) = 0
        DataToSend(8) = 0
        'carry on to fill buffer if neede to Data(63)
        '--------------------------------------------------------------------
        'This procedure send the 64 bytes in the DataToSend Buffer over HID
        '--------------------------------------------------------------------
        HIDDevice.SendPacket(DataToSend)
    End Sub

    '------------------------------------------------------------------------------
    ' Delegate to pass Data between Threads and function to Process arrived Data 
    '-------------------------------------------------------------------------------
    Private Sub HIDDevice_DataArrived(ByRef DataArray() As Byte) Handles HIDDevice.DataArrived
        ProcessData(DataArray)
    End Sub
    '------------------------------------------------------------------------------
    'process incomming USB Data
    '-------------------------------------------------------------------------------
    Sub ProcessData(ByRef Data() As Byte)
        Dim DS As ProcessDataDelegateSub = New ProcessDataDelegateSub(AddressOf ProcessData)
        If InvokeRequired() Then
            Invoke(DS, Data)
        Else
            '----------------------------------------------------------------------
            'Handle incomming Data Read From HID USB Buffer  
            '----------------------------------------------------------------------
            'Display Motor Rpm
            '--------------------------------------------
               

        End If
    End Sub
    '--------------------------------------------------------------------------------
    ' Application Controls and Code
    '---------------------------------------------------------------------------------    
    ' On buttin Click start Timer and Run application
    Private Sub btnRun_Click(ByVal sender As System.Object, ByVal e _
                         As System.EventArgs) Handles btnRun.Click
        EnumDevices() ' Look for device and log the device to application
        HidWriteTimer.Enabled = True 'Start Usb Write Timer
    End Sub
    '----------------------------------------------------------------------------------
    ' On button Click Close Application
    '---------------------------------------------------------------------------------- 
    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e _
                         As System.EventArgs) Handles btnExit.Click
        HidWriteTimer.Enabled = False
        Me.Close()
    End Sub

End Class
