
_C1Interrupt:
	PUSH	RCOUNT
	PUSH	W0
	MOV	#2, W0
	REPEAT	#12
	PUSH	[W0++]

;IO_CAN.c,34 :: 		void C1Interrupt(void) org 0x005A  // ECAN event iterrupt
;IO_CAN.c,37 :: 		IFS2bits.C1IF = 0;      // clear ECAN interrupt flag
	BCLR	IFS2bits, #3
;IO_CAN.c,38 :: 		if(C1INTFbits.TBIF)
	BTSS	C1INTFbits, #0
	GOTO	L_C1Interrupt0
;IO_CAN.c,40 :: 		C1INTFbits.TBIF = 0;  // if yes clear tx interrupt flag
	BCLR	C1INTFbits, #0
;IO_CAN.c,41 :: 		}
L_C1Interrupt0:
;IO_CAN.c,43 :: 		if(C1INTFbits.RBIF)
	BTSS	C1INTFbits, #1
	GOTO	L_C1Interrupt1
;IO_CAN.c,45 :: 		C1INTFbits.RBIF = 0;  // if yes clear rx interrupt flag
	BCLR	C1INTFbits, #1
;IO_CAN.c,46 :: 		}
L_C1Interrupt1:
;IO_CAN.c,47 :: 		}
L_end_C1Interrupt:
	MOV	#26, W0
	REPEAT	#12
	POP	[W0--]
	POP	W0
	POP	RCOUNT
	RETFIE
; end of _C1Interrupt

_IO_CanRead:

;IO_CAN.c,49 :: 		void IO_CanRead()
;IO_CAN.c,51 :: 		Msg_Rcvd = ECAN1Read(&RxID,RxData,&RxDataLen,&Can_Rcv_Flags);
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
	MOV	#lo_addr(_Can_Rcv_Flags), W13
	MOV	#lo_addr(_RxDataLen), W12
	MOV	#lo_addr(_RxData), W11
	MOV	#lo_addr(_RxID), W10
	CALL	_ECAN1Read
	MOV	#lo_addr(_Msg_Rcvd), W1
	MOV.B	W0, [W1]
;IO_CAN.c,52 :: 		if(Msg_Rcvd!=0)
	CP.B	W0, #0
	BRA NZ	L__IO_CanRead10
	GOTO	L_IO_CanRead2
L__IO_CanRead10:
;IO_CAN.c,54 :: 		switch (RxID)
	GOTO	L_IO_CanRead3
;IO_CAN.c,56 :: 		case 0x211 :
L_IO_CanRead5:
;IO_CAN.c,57 :: 		CMD_Control = RxData[0];
	MOV	#lo_addr(_CMD_Control), W1
	MOV	#lo_addr(_RxData), W0
	MOV.B	[W0], [W1]
;IO_CAN.c,58 :: 		DesiredSpeed = (RxData[1]* 40);
	MOV	#lo_addr(_RxData+1), W0
	ZE	[W0], W1
	MOV	#40, W0
	MUL.SS	W1, W0, W0
	MOV	W0, _DesiredSpeed
;IO_CAN.c,59 :: 		break;
	GOTO	L_IO_CanRead4
;IO_CAN.c,60 :: 		case 0x310:
L_IO_CanRead6:
;IO_CAN.c,61 :: 		asm nop;
	NOP
;IO_CAN.c,62 :: 		break;
	GOTO	L_IO_CanRead4
;IO_CAN.c,63 :: 		case 0x410 :
L_IO_CanRead7:
;IO_CAN.c,64 :: 		asm nop;
	NOP
;IO_CAN.c,65 :: 		break;
	GOTO	L_IO_CanRead4
;IO_CAN.c,67 :: 		}// end switch case
L_IO_CanRead3:
	MOV	#529, W1
	MOV	#0, W2
	MOV	#lo_addr(_RxID), W0
	CP	W1, [W0++]
	CPB	W2, [W0--]
	BRA NZ	L__IO_CanRead11
	GOTO	L_IO_CanRead5
L__IO_CanRead11:
	MOV	#784, W1
	MOV	#0, W2
	MOV	#lo_addr(_RxID), W0
	CP	W1, [W0++]
	CPB	W2, [W0--]
	BRA NZ	L__IO_CanRead12
	GOTO	L_IO_CanRead6
L__IO_CanRead12:
	MOV	#1040, W1
	MOV	#0, W2
	MOV	#lo_addr(_RxID), W0
	CP	W1, [W0++]
	CPB	W2, [W0--]
	BRA NZ	L__IO_CanRead13
	GOTO	L_IO_CanRead7
L__IO_CanRead13:
L_IO_CanRead4:
;IO_CAN.c,69 :: 		}
L_IO_CanRead2:
;IO_CAN.c,70 :: 		}
L_end_IO_CanRead:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
	RETURN
; end of _IO_CanRead

_IO_CanWrite:

;IO_CAN.c,72 :: 		void IO_CanWrite()
;IO_CAN.c,74 :: 		ServoStatus = CMD_Control;
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
	MOV	#lo_addr(_ServoStatus), W1
	MOV	#lo_addr(_CMD_Control), W0
	MOV.B	[W0], [W1]
;IO_CAN.c,75 :: 		TxData[0] = ServoStatus;
	MOV	#lo_addr(_TxData), W1
	MOV	#lo_addr(_CMD_Control), W0
	MOV.B	[W0], [W1]
;IO_CAN.c,76 :: 		TxData[1] = (ActualSpeed &0xFF);
	MOV	_ActualSpeed, W2
	MOV.B	#255, W1
	MOV	#lo_addr(_TxData+1), W0
	AND.B	W2, W1, [W0]
;IO_CAN.c,77 :: 		TxData[2] = (ActualSpeed >> 8);
	MOV	_ActualSpeed, W0
	ASR	W0, #8, W1
	MOV	#lo_addr(_TxData+2), W0
	MOV.B	W1, [W0]
;IO_CAN.c,78 :: 		TxData[3] = (MotTemperature + 40);
	MOV	#lo_addr(_MotTemperature), W0
	MOV.B	[W0], W2
	MOV.B	#40, W1
	MOV	#lo_addr(_TxData+3), W0
	ADD.B	W2, W1, [W0]
;IO_CAN.c,79 :: 		TxID = 0x210;
	MOV	#528, W0
	MOV	#0, W1
	MOV	W0, _TxID
	MOV	W1, _TxID+2
;IO_CAN.c,80 :: 		ECAN1Write(TxID,TxData,4,Can_Send_Flags);
	MOV	#4, W13
	MOV	#lo_addr(_TxData), W12
	MOV	#528, W10
	MOV	#0, W11
	PUSH	_Can_Send_Flags
	CALL	_ECAN1Write
	SUB	#2, W15
;IO_CAN.c,82 :: 		}
L_end_IO_CanWrite:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
	RETURN
; end of _IO_CanWrite

_IO_CAN_Init:

;IO_CAN.c,84 :: 		void IO_CAN_Init()
;IO_CAN.c,86 :: 		AD1PCFGL = 0xFFFF;      // PORTB pins as Digital
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
	MOV	#65535, W0
	MOV	WREG, AD1PCFGL
;IO_CAN.c,92 :: 		Unlock_IOLOCK();
	CALL	_Unlock_IOLOCK
;IO_CAN.c,93 :: 		PPS_Mapping_NoLock(9,_OUTPUT,_C1TX);
	MOV.B	#16, W12
	CLR	W11
	MOV.B	#9, W10
	CALL	_PPS_Mapping_NoLock
;IO_CAN.c,94 :: 		PPS_Mapping_NoLock(7,_INPUT,_CIRX);
	MOV.B	#29, W12
	MOV.B	#1, W11
	MOV.B	#7, W10
	CALL	_PPS_Mapping_NoLock
;IO_CAN.c,95 :: 		Lock_IOLOCK();
	CALL	_Lock_IOLOCK
;IO_CAN.c,98 :: 		IFS0=0;
	CLR	IFS0
;IO_CAN.c,99 :: 		IFS1=0;
	CLR	IFS1
;IO_CAN.c,100 :: 		IFS2=0;
	CLR	IFS2
;IO_CAN.c,101 :: 		IFS3=0;
	CLR	IFS3
;IO_CAN.c,102 :: 		IFS4=0;
	CLR	IFS4
;IO_CAN.c,105 :: 		IEC2bits.C1IE   = 1;             // enable ECAN1 interrupts
	BSET	IEC2bits, #3
;IO_CAN.c,106 :: 		C1INTEbits.TBIE = 1;            // enable ECAN1 tx interrupt
	BSET.B	C1INTEbits, #0
;IO_CAN.c,107 :: 		C1INTEbits.RBIE = 1;            // enable ECAN1 rx interrupt
	BSET.B	C1INTEbits, #1
;IO_CAN.c,108 :: 		Can_Init_Flags = 0;             //
	CLR	W0
	MOV	W0, _Can_Init_Flags
;IO_CAN.c,109 :: 		Can_Send_Flags = 0;             // clear flags
	CLR	W0
	MOV	W0, _Can_Send_Flags
;IO_CAN.c,110 :: 		Can_Rcv_Flags  = 0;             //
	CLR	W0
	MOV	W0, _Can_Rcv_Flags
;IO_CAN.c,114 :: 		_ECAN_TX_NO_RTR_FRAME;
	MOV	#252, W0
	MOV	W0, _Can_Send_Flags
;IO_CAN.c,120 :: 		_ECAN_CONFIG_LINE_FILTER_OFF;
	MOV	#249, W0
	MOV	W0, _Can_Init_Flags
;IO_CAN.c,123 :: 		ECAN1DmaChannelInit(0, 1, &ECAN1RxTxRAMBuffer);
	MOV	#16384, W12
	MOV	#1, W11
	CLR	W10
	CALL	_ECAN1DmaChannelInit
;IO_CAN.c,125 :: 		ECAN1DmaChannelInit(2, 0, &ECAN1RxTxRAMBuffer);
	MOV	#16384, W12
	CLR	W11
	MOV	#2, W10
	CALL	_ECAN1DmaChannelInit
;IO_CAN.c,127 :: 		ECAN1Initialize(1, 1, 3, 3, 3, Can_Init_Flags);
	MOV	#3, W13
	MOV	#3, W12
	MOV	#1, W11
	MOV	#1, W10
	PUSH	_Can_Init_Flags
	MOV	#3, W0
	PUSH	W0
	CALL	_ECAN1Initialize
	SUB	#4, W15
;IO_CAN.c,129 :: 		ECAN1SetBufferSize(ECAN1RAMBUFFERSIZE);
	MOV	#16, W10
	CALL	_ECAN1SetBufferSize
;IO_CAN.c,131 :: 		ECAN1SelectTxBuffers(0x000F);
	MOV	#15, W10
	CALL	_ECAN1SelectTxBuffers
;IO_CAN.c,133 :: 		ECAN1SetOperationMode(_ECAN_MODE_CONFIG,0xFF);
	MOV	#255, W11
	MOV	#4, W10
	CALL	_ECAN1SetOperationMode
;IO_CAN.c,135 :: 		_ECAN_CONFIG_STD_MSG);     // set all mask1 bits to ones
	MOV	#255, W13
;IO_CAN.c,134 :: 		ECAN1SetMask(_ECAN_MASK_0, -1,_ECAN_CONFIG_MATCH_MSG_TYPE &
	MOV	#65535, W11
	MOV	#65535, W12
	CLR	W10
;IO_CAN.c,135 :: 		_ECAN_CONFIG_STD_MSG);     // set all mask1 bits to ones
	CALL	_ECAN1SetMask
;IO_CAN.c,137 :: 		_ECAN_CONFIG_STD_MSG);    // set all mask2 bits to ones
	MOV	#255, W13
;IO_CAN.c,136 :: 		ECAN1SetMask(_ECAN_MASK_1,-1,_ECAN_CONFIG_MATCH_MSG_TYPE &
	MOV	#65535, W11
	MOV	#65535, W12
	MOV	#1, W10
;IO_CAN.c,137 :: 		_ECAN_CONFIG_STD_MSG);    // set all mask2 bits to ones
	CALL	_ECAN1SetMask
;IO_CAN.c,139 :: 		_ECAN_CONFIG_STD_MSG);  // set all mask3 bits to ones
	MOV	#255, W13
;IO_CAN.c,138 :: 		ECAN1SetMask(_ECAN_MASK_2,-1,_ECAN_CONFIG_MATCH_MSG_TYPE &
	MOV	#65535, W11
	MOV	#65535, W12
	MOV	#2, W10
;IO_CAN.c,139 :: 		_ECAN_CONFIG_STD_MSG);  // set all mask3 bits to ones
	CALL	_ECAN1SetMask
;IO_CAN.c,140 :: 		ECAN1SetFilter(_ECAN_FILTER_10,0x211,_ECAN_MASK_2,_ECAN_RX_BUFFER_7,
	MOV	#2, W13
	MOV	#529, W11
	MOV	#0, W12
	MOV	#10, W10
;IO_CAN.c,141 :: 		_ECAN_CONFIG_STD_MSG);  // set id of filter10
	MOV	#255, W0
	PUSH	W0
;IO_CAN.c,140 :: 		ECAN1SetFilter(_ECAN_FILTER_10,0x211,_ECAN_MASK_2,_ECAN_RX_BUFFER_7,
	MOV	#7, W0
	PUSH	W0
;IO_CAN.c,141 :: 		_ECAN_CONFIG_STD_MSG);  // set id of filter10
	CALL	_ECAN1SetFilter
	SUB	#4, W15
;IO_CAN.c,142 :: 		ECAN1SetOperationMode(_ECAN_MODE_NORMAL, 0xFF); // set NORMAL mode
	MOV	#255, W11
	CLR	W10
	CALL	_ECAN1SetOperationMode
;IO_CAN.c,143 :: 		Msg_Rcvd = 0;
	MOV	#lo_addr(_Msg_Rcvd), W1
	CLR	W0
	MOV.B	W0, [W1]
;IO_CAN.c,144 :: 		}
L_end_IO_CAN_Init:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
	RETURN
; end of _IO_CAN_Init
