#line 1 "D:/Application Projects/USB(HID) CAN Controlled Motor Application/Servo Controller Node/IO_CAN.c"
#line 1 "d:/application projects/usb(hid) can controlled motor application/servo controller node/io_can.h"






void IO_CAN_Init(void);
void IO_CanRead(void);
void IO_CanWrite(void);
#line 1 "d:/application projects/usb(hid) can controlled motor application/servo controller node/ecan_defs.h"
#line 13 "d:/application projects/usb(hid) can controlled motor application/servo controller node/ecan_defs.h"
typedef
 struct {
 struct {
 IDE : 1;
 SRR : 1;
 SID : 11;
 : 3;
 } CxTRBnSID;
 struct {
 EID17_6 : 12;
 : 4;
 } CxTRBnEID;
 struct {
 DLC : 4;
 RB0 : 1;
 : 3;
 RB1 : 1;
 RTR : 1;
 EID5_0 : 6;
 } CxTRBnDLC;
 struct d{
 char Data[8];
 } CxTRBnData;
 struct {
 : 8;
 FILHIT : 5;

 : 3;
 } CxTRBnSTAT;
 } __RxTxBuffer;
#line 57 "d:/application projects/usb(hid) can controlled motor application/servo controller node/ecan_defs.h"
unsigned dma ECAN1RamStartAddress = 0x4000;

__RxTxBuffer dma ECAN1RxTxRAMBuffer[ 16 ] absolute 0x4000;
#line 7 "D:/Application Projects/USB(HID) CAN Controlled Motor Application/Servo Controller Node/IO_CAN.c"
unsigned int Can_Init_Flags, Can_Send_Flags, Can_Rcv_Flags;
unsigned int RxDataLen;
unsigned int TxDataLen;
char RxData[8];
char TxData[8];
char Msg_Rcvd;
unsigned long RxID;
unsigned long TxID;

extern int ActualSpeed;
extern int DesiredSpeed;
unsigned char CMD_Control = 0;
unsigned char ServoStatus = 0;
unsigned char MotTemperature = 0;
extern struct MotorFlags
{
unsigned RunMotor :1;
unsigned Direction :1;
unsigned isRunning :1;
unsigned CloseLoop :1;
unsigned swDirection :1;
unsigned unused :11;
}Flags;




void C1Interrupt(void) org 0x005A
{

 IFS2bits.C1IF = 0;
 if(C1INTFbits.TBIF)
 {
 C1INTFbits.TBIF = 0;
 }

 if(C1INTFbits.RBIF)
 {
 C1INTFbits.RBIF = 0;
 }
}

void IO_CanRead()
{
 Msg_Rcvd = ECAN1Read(&RxID,RxData,&RxDataLen,&Can_Rcv_Flags);
 if(Msg_Rcvd!=0)
 {
 switch (RxID)
 {
 case 0x211 :
 CMD_Control = RxData[0];
 DesiredSpeed = (RxData[1]* 40);
 break;
 case 0x310:
 asm nop;
 break;
 case 0x410 :
 asm nop;
 break;

 }

 }
}

void IO_CanWrite()
{
 ServoStatus = CMD_Control;
 TxData[0] = ServoStatus;
 TxData[1] = (ActualSpeed &0xFF);
 TxData[2] = (ActualSpeed >> 8);
 TxData[3] = (MotTemperature + 40);
 TxID = 0x210;
 ECAN1Write(TxID,TxData,4,Can_Send_Flags);

}

void IO_CAN_Init()
{
 AD1PCFGL = 0xFFFF;





 Unlock_IOLOCK();
 PPS_Mapping_NoLock(9,_OUTPUT,_C1TX);
 PPS_Mapping_NoLock(7,_INPUT,_CIRX);
 Lock_IOLOCK();


 IFS0=0;
 IFS1=0;
 IFS2=0;
 IFS3=0;
 IFS4=0;


 IEC2bits.C1IE = 1;
 C1INTEbits.TBIE = 1;
 C1INTEbits.RBIE = 1;
 Can_Init_Flags = 0;
 Can_Send_Flags = 0;
 Can_Rcv_Flags = 0;

 Can_Send_Flags = _ECAN_TX_PRIORITY_0 &
 _ECAN_TX_STD_FRAME &
 _ECAN_TX_NO_RTR_FRAME;

 Can_Init_Flags = _ECAN_CONFIG_SAMPLE_THRICE &
 _ECAN_CONFIG_PHSEG2_PRG_ON &
 _ECAN_CONFIG_STD_MSG &
 _ECAN_CONFIG_MATCH_MSG_TYPE &
 _ECAN_CONFIG_LINE_FILTER_OFF;


 ECAN1DmaChannelInit(0, 1, &ECAN1RxTxRAMBuffer);

 ECAN1DmaChannelInit(2, 0, &ECAN1RxTxRAMBuffer);

 ECAN1Initialize(1, 1, 3, 3, 3, Can_Init_Flags);

 ECAN1SetBufferSize( 16 );

 ECAN1SelectTxBuffers(0x000F);

 ECAN1SetOperationMode(_ECAN_MODE_CONFIG,0xFF);
 ECAN1SetMask(_ECAN_MASK_0, -1,_ECAN_CONFIG_MATCH_MSG_TYPE &
 _ECAN_CONFIG_STD_MSG);
 ECAN1SetMask(_ECAN_MASK_1,-1,_ECAN_CONFIG_MATCH_MSG_TYPE &
 _ECAN_CONFIG_STD_MSG);
 ECAN1SetMask(_ECAN_MASK_2,-1,_ECAN_CONFIG_MATCH_MSG_TYPE &
 _ECAN_CONFIG_STD_MSG);
 ECAN1SetFilter(_ECAN_FILTER_10,0x211,_ECAN_MASK_2,_ECAN_RX_BUFFER_7,
 _ECAN_CONFIG_STD_MSG);
 ECAN1SetOperationMode(_ECAN_MODE_NORMAL, 0xFF);
 Msg_Rcvd = 0;
}
