#line 1 "D:/Application Projects/USB(HID) CAN Controlled Motor Application/Servo Controller Node/MotorControl.c"
#line 1 "d:/application projects/usb(hid) can controlled motor application/servo controller node/motorcontrol.h"




void InitMCPWM(void);
void InitADC10(void);
void StartMotorFWD(void);
void StartMotorREV(void);
void StopMotor(void);
#line 7 "D:/Application Projects/USB(HID) CAN Controlled Motor Application/Servo Controller Node/MotorControl.c"
unsigned int HallValue;
unsigned int timer3value;
unsigned int timer3avg;
int DesiredSpeed;
int ActualSpeed;
int SpeedError;
long SpeedIntegral = 0, SpeedIntegral_n_1 = 0, SpeedProportional = 0;
long DutyCycle = 0;
unsigned int Kps = 20000;
unsigned int Kis = 2000;
unsigned char polecount;
#line 34 "D:/Application Projects/USB(HID) CAN Controlled Motor Application/Servo Controller Node/MotorControl.c"
unsigned int StateTableFwd[] = {0x0000, 0x0210, 0x2004, 0x0204,
 0x0801, 0x0810, 0x2001, 0x0000};
unsigned int StateTableRev[] = {0x0000, 0x2001, 0x0810, 0x0801,
 0x0204, 0x2004, 0x0210, 0x0000};



extern unsigned char MotTemperature;



struct MotorFlags
{
unsigned RunMotor :1;
unsigned Direction :1;
unsigned isRunning :1;
unsigned CloseLoop :1;
unsigned swDirection :1;
unsigned unused :11;
}Flags;




 void Timer1Int() iv IVT_ADDR_T1INTERRUPT
{
 T1IF_bit = 0;
 ActualSpeed =  2343750 /timer3avg;
if(Flags.CloseLoop)
{
 SpeedError = DesiredSpeed - ActualSpeed;
 SpeedProportional = (int)(((long)Kps*(long)SpeedError) >> 15);
 SpeedIntegral = SpeedIntegral_n_1 + (int)(((long)Kis*(long)SpeedError) >> 15);

 if (SpeedIntegral < 0)
 SpeedIntegral = 0;
 else if (SpeedIntegral > 32767)
 SpeedIntegral = 32767;
 SpeedIntegral_n_1 = SpeedIntegral;
 DutyCycle = SpeedIntegral + SpeedProportional;
 if (DutyCycle < 0)
 DutyCycle = 0;
 else if (DutyCycle > 32767)
 DutyCycle = 32767;

 PDC1 = (int)(((long)(PTPER*2)*(long)DutyCycle) >> 15);
 PDC2 = PDC1;
 PDC3 = PDC1;
 }
 if(Flags.RunMotor == 0) { ActualSpeed = 0;}

}



void IC1Int() iv IVT_ADDR_IC1INTERRUPT
{
 int Hall_Index;
 IFS0bits.IC1IF = 0;
 HallValue = (unsigned int)((PORTB >> 1) & 0x0007);

if (Flags.Direction)
 {
 OVDCON = StateTableFwd[HallValue];
 Hall_Index =  5 ;
 }
else
 {
 OVDCON = StateTableRev[HallValue];
 Hall_Index =  4 ;
 }


 if (HallValue == Hall_Index)
 if (polecount++ ==  5 )
 {
 timer3value = TMR3;
 TMR3 = 0;
 timer3avg = ((timer3avg + timer3value) >> 1);
 polecount = 1;
 }
}

void IC2Int() iv IVT_ADDR_IC2INTERRUPT
{
 IFS0bits.IC2IF = 0;
 HallValue = (unsigned int)((PORTB >> 1) & 0x0007);

 if (Flags.Direction)
 OVDCON = StateTableFwd[HallValue];
 else
 OVDCON = StateTableRev[HallValue];
}

void IC7Int() iv IVT_ADDR_IC7INTERRUPT
{
 IFS1bits.IC7IF = 0;
 HallValue = (unsigned int)((PORTB >> 1) & 0x0007);
 if (Flags.Direction)
 OVDCON = StateTableFwd[HallValue];
 else
 OVDCON = StateTableRev[HallValue];
}

void AdcInt() iv IVT_ADDR_ADC1INTERRUPT
{
 IFS0bits.AD1IF = 0;

 MotTemperature =(ADC1BUF0/5);
}



void StartMotorFWD()
{
 PWMCON1 = 0x0777;
 HallValue = (unsigned int)((PORTB >> 1) & 0x0007);
 OVDCON = StateTableFwd[HallValue];
 PDC1 = PDC2 = PDC3 = 200;
 T3CONbits.TON = 1;
 polecount = 1;
 Flags.isRunning = 1;
}



void StartMotorREV()
{
 PWMCON1 = 0x0777;
 HallValue = (unsigned int)((PORTB >> 1) & 0x0007);
 OVDCON = StateTableRev[HallValue];
 PDC1 = PDC2 = PDC3 = 200;
 T3CONbits.TON = 1;
 polecount = 1;
 Flags.isRunning = 1;
}



void StopMotor(void)
{
 PDC1 = PDC2 = PDC3 = 100;
 PWMCON1 = 0x0700;
 Flags.CloseLoop = 0;
 Flags.isRunning = 0;
}

void InitMCPWM(void)
{



 Unlock_IOLOCK();
 PPS_Mapping_NoLock(1,_INPUT ,_IC1);
 PPS_Mapping_NoLock(2,_INPUT ,_IC2);
 PPS_Mapping_NoLock(3,_INPUT ,_IC7);
 Lock_IOLOCK();



 TRISBbits.TRISB15 = 0;
 TRISBbits.TRISB14 = 0;
 TRISBbits.TRISB13 = 0;
 TRISBbits.TRISB12 = 0;
 TRISBbits.TRISB11 = 0;
 TRISBbits.TRISB10 = 0;
 TRISBbits.TRISB3 = 1;
 TRISBbits.TRISB2 = 1;







 T1CON = 0x8020;
 TMR1 = 0;
 PR1 =  (( 20000000 /2 /1000)/64) ;
 T1CONbits.TON = 1;
 IFS0bits.T1IF = 0;
 IEC0bits.T1IE = 1;



 T3CON = 0x0030;
 TMR3 = 0;
 PR3 = 0xFFFF;






 IC1CON = 1;
 IC2CON = 1;
 IC7CON = 1;

 IFS0bits.IC1IF = 0;
 IFS0bits.IC2IF = 0;
 IFS1bits.IC7IF = 0;
 IEC0bits.IC1IE = 1;
 IEC0bits.IC2IE = 1;
 IEC1bits.IC7IE = 1;

 PTPER =  20000000 /2 / 39000  - 1;
 PWMCON1 = 0x0700;
 OVDCON = 0x0000;
 PDC1 = 100;
 PDC2 = 100;
 PDC3 = 100;
 SEVTCMP = PTPER;
 PWMCON2 = 0x0F00;
 PTCON = 0x8000;



 Flags.RunMotor = 0;
 Flags.Direction = 0;
 Flags.isRunning = 0;
 ActualSpeed = 0;
}

void InitADC10(void)
{
 AD1PCFGLbits.PCFG8 = 0;
#line 261 "D:/Application Projects/USB(HID) CAN Controlled Motor Application/Servo Controller Node/MotorControl.c"
 AD1CON1 = 0x006C;

 AD1CON1bits.AD12B = 0;
#line 266 "D:/Application Projects/USB(HID) CAN Controlled Motor Application/Servo Controller Node/MotorControl.c"
 AD1CON2 = 0x0000;

 AD1CON3 = 0x032F;
 AD1CSSL = 0x0000;

 AD1CHS0 = 0x0008;
 IFS0bits.AD1IF = 0;
 IEC0bits.AD1IE = 1;
 AD1CON1bits.ADON = 1;
}
